# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from typing import Optional

from ..._models import BaseModel
from .http_method import HTTPMethod
from .provisioning_status import ProvisioningStatus
from .lb_health_monitor_type import LbHealthMonitorType
from .load_balancer_operating_status import LoadBalancerOperatingStatus

__all__ = ["HealthMonitor"]


class HealthMonitor(BaseModel):
    id: str
    """Health monitor ID"""

    admin_state_up: bool
    """true if enabled. Defaults to true"""

    delay: int
    """The time, in seconds, between sending probes to members"""

    max_retries: int
    """Number of successes before the member is switched to ONLINE state"""

    max_retries_down: int
    """Number of failures before the member is switched to ERROR state"""

    operating_status: LoadBalancerOperatingStatus
    """Health Monitor operating status"""

    provisioning_status: ProvisioningStatus
    """Health monitor lifecycle status"""

    timeout: int
    """The maximum time to connect. Must be less than the delay value"""

    type: LbHealthMonitorType
    """Health monitor type. Once health monitor is created, cannot be changed."""

    expected_codes: Optional[str] = None

    http_method: Optional[HTTPMethod] = None
    """HTTP method"""

    url_path: Optional[str] = None
    """URL Path. Defaults to '/'"""
